# -*- mode: ruby -*-
# vi: set ft=ruby

Vagrant.configure("2") do |config|
    # configure the boxes
    config.vm.box = "bento/ubuntu-17.04"

    #
    # Sample app to be monitored
    #
    config.vm.define 'app-one' do |app1|
        app1.vm.hostname = 'app-1'
        app1.vm.network "private_network", ip: "172.20.20.10"
        app1.vm.provision "shell", privileged: true, path: "install_ansible_agt.sh"
    end

    #
    # ELK node
    #
    config.vm.define 'elk-one' do |elk1|
        elk1.vm.hostname = 'elk-1'
        elk1.vm.network "private_network", ip: "172.20.20.20"
        elk1.vm.network "forwarded_port", guest: 5601, host: 5601
        elk1.vm.provision "shell", privileged: true, path: "install_ansible_agt.sh"
        elk1.vm.provider "virtualbox" do |hw|
            hw.memory = 2048
        end
    end

    #
    # Ansible controller node
    #
    config.vm.define 'controller' do |controller|
        controller.vm.hostname = "controller"
        controller.vm.network "private_network", ip: "172.20.20.99"
        controller.vm.provision "shell", privileged: true, inline: <<-EOF
            sudo apt-get update -y
            
            # Good tools to have
            sudo apt-get install -y tree htop

            # Setup vim profile
            cp /vagrant/.vimrc ~/
        EOF
        controller.vm.provision "shell", privileged: true, path: "install_ansible_ctl.sh"
    end
end